import Data.Array

rearrange ((x,y),z) = (x,(y,z))

segSum :: Array Int Int -> (Int,(Int,Int))
segSum ar = (rearrange.maximum) (zip (elems bA) [b..e])
 where
 (b,e) = bounds ar
 bA :: Array Int (Int,Int)
 bA = array (b,e) [(i,(f i,g i)) | i <- [b..e]]
 f i 
  | (i == b) = ar!b
  | otherwise = if (fst (bA!(i-1)) > 0) then (ar!i + fst (bA!(i-1))) else ar!i
 g i 
  | (i == b) = b
  | otherwise = if (fst (bA!(i-1)) > 0) then (snd (bA!(i-1))) else  i

listToArray :: [a] -> Array Int a
listToArray l = listArray (0, (length l)-1) l
 
